Index: trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/physiq_mod.F90	(revision 3083)
@@ -1583,103 +1675,236 @@
       CALL send_xios_field("Declin",declin*180./pi)
       
-      ! Total energy balance diagnostics
-      if (callrad.and.(.not.newtonian)) then
-         CALL send_xios_field("ISR_TOA",fluxtop_dn)
-         CALL send_xios_field("OLR_TOA",fluxtop_lw)
-      endif
-      
-      CALL send_xios_field("area",cell_area)
-      CALL send_xios_field("pphi",pphi)
-      CALL send_xios_field("pphis",phisfi)
-      
-      CALL send_xios_field("ps",ps)
-      CALL send_xios_field("tsurf",tsurf)
-
-      if(enertest) then
-         if (calldifv) then
-            CALL send_xios_field("sensibFlux",sensibFlux)
-         endif
-      endif
-
+      ! Atmosphere (3D) :
       CALL send_xios_field("temp",zt)
       CALL send_xios_field("teta",zh)
+      CALL send_xios_field("p",pplay)
       CALL send_xios_field("u",zu)
       CALL send_xios_field("v",zv)
       CALL send_xios_field("w",pw)
-      CALL send_xios_field("p",pplay)
-      
-      ! Winds diagnostics.
+
+      CALL send_xios_field("area",cell_area)
+      CALL send_xios_field("pphi",pphi)
+
+      ! Surface (2D) :
+      CALL send_xios_field("ps",ps)
+      CALL send_xios_field("tsurf",tsurf)
+      CALL send_xios_field("pphis",phisfi)
+
+      ! Total energy balance diagnostics (2D) :
+      IF (callrad.and.(.not.newtonian)) THEN
+         CALL send_xios_field("ISR_TOA",fluxtop_dn)
+         CALL send_xios_field("OLR_TOA",fluxtop_lw)
+      ENDIF
+
+
+      !--------------------------------------------------------
+      ! Winds trends :
+      !--------------------------------------------------------
+      ! Atmosphere (3D) :
+      ! du_tot = zdudyn + pdu
+      CALL send_xios_field("dudyn",zdudyn)
+      CALL send_xios_field("pdu",pdu)
+      
+      ! pdu = zdudif + zduadj + zdundg
       CALL send_xios_field("dudif",zdudif)
-      CALL send_xios_field("dudyn",zdudyn)
-
+      CALL send_xios_field("duadj",zduadj)
+      CALL send_xios_field("dundg",zdundg)
+      
+      ! zhorizwind = sqrt(u*u + v*v)
       CALL send_xios_field("horizwind",zhorizwind)
 
-      ! Heating diagnostics.
+
+      !--------------------------------------------------------
+      ! Heating trends :
+      !--------------------------------------------------------
+      ! Atmosphere (3D) :
+      ! dt_tot = dtdyn + pdt
+      CALL send_xios_field("dtdyn",zdtdyn)
+      CALL send_xios_field("pdt",pdt)
+
+      ! pdt = dtrad + zdtdif + dtadj + zdtlc
+      CALL send_xios_field("dtrad",dtrad)
+      CALL send_xios_field("dtdif",zdtdif)
+      CALL send_xios_field("dtadj",zdtadj(:,:))
+      CALL send_xios_field("dtlc",zdtlc)
+
+      ! dtrad = zdtsw + zdtlw
       CALL send_xios_field("dtsw",zdtsw)
       CALL send_xios_field("dtlw",zdtlw)
-      CALL send_xios_field("dtrad",dtrad)
-      CALL send_xios_field("dtdyn",zdtdyn)
-      CALL send_xios_field("dtdif",zdtdif)
-
-      ! Chemical tracers
-      if (callchim) then
-      
-        ! Advected fields
-        do iq=1,nkim
-          CALL send_xios_field(trim(cnames(iq)),zq(:,:,iq+nmicro)/rat_mmol(iq+nmicro)) ! kg/kg -> mol/mol
-        enddo
-        
-        ! Upper chemistry fields
-        do iq=1,nkim
-          CALL send_xios_field(trim(cnames(iq))//"_up",ykim_up(iq,:,:)) ! mol/mol
-        enddo
-        
-        ! Append fields in ykim_tot for output on the total vertical grid (0->1300km)
-        do iq=1,nkim
-          
-          ! GCM levels
-          do l=1,nlayer
-            ykim_tot(iq,:,l) = zq(:,l,iq+nmicro)/rat_mmol(iq+nmicro)
-          enddo
-          ! Upper levels
-          do l=1,nlaykim_up
-            ykim_tot(iq,:,nlayer+l) = ykim_up(iq,:,l)
-          enddo
-          
-          CALL send_xios_field(trim(cnames(iq))//"_tot",ykim_tot(iq,:,:)) ! mol/mol
-          
-        enddo
-       
-        ! Condensation tendencies ( mol/mol/s )
-        CALL send_xios_field("dqcond_CH4",dyccond(:,:,7+nmicro))
-        CALL send_xios_field("dqcond_C2H2",dyccond(:,:,10+nmicro))
-        CALL send_xios_field("dqcond_C2H4",dyccond(:,:,12+nmicro))
-        CALL send_xios_field("dqcond_C2H6",dyccond(:,:,14+nmicro))
-        CALL send_xios_field("dqcond_C3H6",dyccond(:,:,17+nmicro))
-        CALL send_xios_field("dqcond_C4H4",dyccond(:,:,21+nmicro))
-        CALL send_xios_field("dqcond_CH3CCH",dyccond(:,:,23+nmicro))
-        CALL send_xios_field("dqcond_C3H8",dyccond(:,:,24+nmicro))
-        CALL send_xios_field("dqcond_C4H2",dyccond(:,:,25+nmicro))
-        CALL send_xios_field("dqcond_C4H6",dyccond(:,:,26+nmicro))
-        CALL send_xios_field("dqcond_C4H10",dyccond(:,:,27+nmicro))
-        CALL send_xios_field("dqcond_AC6H6",dyccond(:,:,28+nmicro))
-        CALL send_xios_field("dqcond_HCN",dyccond(:,:,35+nmicro))
-        CALL send_xios_field("dqcond_CH3CN",dyccond(:,:,39+nmicro))
-        CALL send_xios_field("dqcond_HC3N",dyccond(:,:,41+nmicro))
-        CALL send_xios_field("dqcond_NCCN",dyccond(:,:,42+nmicro))
-        CALL send_xios_field("dqcond_C4N2",dyccond(:,:,43+nmicro))
-
-        ! Pseudo-evaporation flux (mol/mol/s)
-        CALL send_xios_field("evapCH4",dycevapCH4(:))
-
-      endif ! of 'if callchim'
-
-      ! Microphysical tracers
-      if (callmufi) then
-        CALL send_xios_field("mu_m0as",zq(:,:,micro_indx(1))*i2e)
-        CALL send_xios_field("mu_m3as",zq(:,:,micro_indx(2))*i2e)
-        CALL send_xios_field("mu_m0af",zq(:,:,micro_indx(3))*i2e)
-        CALL send_xios_field("mu_m3af",zq(:,:,micro_indx(4))*i2e)
-      endif        
+
+      ! Surface (2D) :
+      IF(enertest) THEN
+         IF (calldifv) THEN
+            CALL send_xios_field("sensibFlux",sensibFlux)
+         ENDIF
+      ENDIF
+      CALL send_xios_field("fluxsurf_lw",fluxsurf_lw(:))
+      CALL send_xios_field("fluxsurfabs_sw",fluxsurfabs_sw(:))
+      CALL send_xios_field("emis",emis(:))
+      
+      ! dtsurf = dtsdif + dtsurfevap
+      CALL send_xios_field("dtsurf",zdtsurf(:))
+      CALL send_xios_field("dtsdif",zdtsdif(:))
+      CALL send_xios_field("dtsurfevap",zdtsurfevap(:))
+      
+
+      !--------------------------------------------------------
+      ! Optical diagnostics :
+      !--------------------------------------------------------
+      ! Optics diagnostics for haze (Channel VI04 : 2.80um).
+      CALL send_xios_field('tauhv_04',zpopthv(:,:,4,2))
+      CALL send_xios_field('khv_04',zpopthv(:,:,4,3))
+      CALL send_xios_field('wbarhv_04',zpopthv(:,:,4,4))
+      CALL send_xios_field('gbarhv_04',zpopthv(:,:,4,5))
+      ! Optics diagnostics for haze (Channel VI18 : 0.85um).
+      CALL send_xios_field('tauhv_18',zpopthv(:,:,18,2))
+      CALL send_xios_field('khv_18',zpopthv(:,:,18,3))
+      CALL send_xios_field('wbarhv_18',zpopthv(:,:,18,4))
+      CALL send_xios_field('gbarhv_18',zpopthv(:,:,18,5))
+      ! Optics diagnostics for haze (Channel IR07 : 29.5um).
+      CALL send_xios_field('tauhi_07',zpopthi(:,:,7,2))
+      CALL send_xios_field('khi_07',zpopthi(:,:,7,3))
+      CALL send_xios_field('wbarhi_07',zpopthi(:,:,7,4))
+      CALL send_xios_field('gbarhi_07',zpopthi(:,:,7,5))
+      ! Optics diagnostics for haze (Channel IR22 : 5.66um).
+      CALL send_xios_field('tauhi_22',zpopthi(:,:,22,2))
+      CALL send_xios_field('khi_22',zpopthi(:,:,22,3))
+      CALL send_xios_field('wbarhi_22',zpopthi(:,:,22,4))
+      CALL send_xios_field('gbarhi_22',zpopthi(:,:,22,5))
+
+      ! Optics diagnostics for haze + clouds (Channel VI04 : 2.80um).
+      CALL send_xios_field('taucv_04',zpoptcv(:,:,4,2))
+      CALL send_xios_field('kcv_04',zpoptcv(:,:,4,3))
+      CALL send_xios_field('wbarcv_04',zpoptcv(:,:,4,4))
+      CALL send_xios_field('gbarcv_04',zpoptcv(:,:,4,5))
+      ! Optics diagnostics for haze + clouds (Channel VI18 : 0.85um).
+      CALL send_xios_field('taucv_18',zpoptcv(:,:,18,2))
+      CALL send_xios_field('kcv_18',zpoptcv(:,:,18,3))
+      CALL send_xios_field('wbarcv_18',zpoptcv(:,:,18,4))
+      CALL send_xios_field('gbarcv_18',zpoptcv(:,:,18,5))
+      ! Optics diagnostics for haze + clouds (Channel IR07 : 29.5um).
+      CALL send_xios_field('tauci_07',zpoptci(:,:,7,2))
+      CALL send_xios_field('kci_07',zpoptci(:,:,7,3))
+      CALL send_xios_field('wbarci_07',zpoptci(:,:,7,4))
+      CALL send_xios_field('gbarci_07',zpoptci(:,:,7,5))
+      ! Optics diagnostics for haze + clouds (Channel IR22 : 5.66um).
+      CALL send_xios_field('tauci_22',zpoptci(:,:,22,2))
+      CALL send_xios_field('kci_22',zpoptci(:,:,22,3))
+      CALL send_xios_field('wbarci_22',zpoptci(:,:,22,4))
+      CALL send_xios_field('gbarci_22',zpoptci(:,:,22,5))
+
+      ! >>> [TEMPO : BBT]
+      !DO nw = 1, L_NSPECTV
+      !   WRITE(str2,'(i2.2)') nw
+      !   CALL send_xios_field('khv'//TRIM(nw),zpopthv(:,:,nw,3))
+      !ENDDO
+      ! <<< [TEMPO : BBT]
+      
+
+      !--------------------------------------------------------
+      ! Microphysical tracers :
+      !--------------------------------------------------------
+      IF (callmufi) THEN
+         ! Atmosphere (3D) :
+         ! Moments M0 and M3 :
+         CALL send_xios_field("mu_m0as",zq(:,:,micro_indx(1))*i2e)
+         CALL send_xios_field("mu_m3as",zq(:,:,micro_indx(2))*i2e)
+         CALL send_xios_field("mu_m0af",zq(:,:,micro_indx(3))*i2e)
+         CALL send_xios_field("mu_m3af",zq(:,:,micro_indx(4))*i2e)
+         IF (callclouds) THEN
+            CALL send_xios_field("mu_m0n",zq(:,:,micro_indx(5))*i2e)
+            CALL send_xios_field("mu_m3n",zq(:,:,micro_indx(6))*i2e)
+            DO iq = 1, size(ices_indx)
+               CALL send_xios_field(TRIM(nameOfTracer(ices_indx(iq))),zq(:,:,ices_indx(iq))*i2e)
+            ENDDO
+         ENDIF
+
+         ! Microphysical diagnostics :
+         CALL send_xios_field("rc_sph",mmd_rc_sph(:,:))
+         CALL send_xios_field("rc_fra",mmd_rc_fra(:,:))
+         CALL send_xios_field("vsed_aers",mmd_aer_s_w(:,:))
+         CALL send_xios_field("vsed_aerf",mmd_aer_f_w(:,:))
+         CALL send_xios_field("flux_aers",mmd_aer_s_flux(:,:))
+         CALL send_xios_field("flux_aerf",mmd_aer_f_flux(:,:))
+         IF (callclouds) THEN
+            CALL send_xios_field("rc_cld",mmd_rc_cld(:,:))
+            CALL send_xios_field("vsed_ccn",mmd_ccn_w(:,:))
+            CALL send_xios_field("flux_ccn",mmd_ccn_flux(:,:))
+            CALL send_xios_field("flux_iCH4",mmd_ice_fluxes(:,:,1))
+            CALL send_xios_field("flux_iC2H2",mmd_ice_fluxes(:,:,2))
+            CALL send_xios_field("flux_iC2H6",mmd_ice_fluxes(:,:,3))
+            CALL send_xios_field("flux_iHCN",mmd_ice_fluxes(:,:,3))
+            DO iq = 1, size(ices_indx)
+               CALL send_xios_field(TRIM(nameOfTracer(gazs_indx(iq)))//'_sat',mmd_gazs_sat(:,:,iq))
+            ENDDO
+         ENDIF
+         
+         ! Surface (2D) :
+         CALL send_xios_field("aer_prec",mmd_aer_prec(:))
+         CALL send_xios_field("ccn_prec",mmd_ccn_prec(:))
+         CALL send_xios_field("iCH4_prec",mmd_ice_prec(:,1))
+         CALL send_xios_field("iC2H2_prec",mmd_ice_prec(:,2))
+         CALL send_xios_field("iC2H6_prec",mmd_ice_prec(:,3))
+         CALL send_xios_field("iHCN_prec",mmd_ice_prec(:,3)) 
+      ENDIF ! of 'if callmufi'
+
+      !--------------------------------------------------------
+      ! Chemical tracers :
+      !--------------------------------------------------------
+      IF (callchim) THEN
+         ! Atmosphere (3D) :
+         ! Chemical species :
+         DO iq = 1, nkim
+            CALL send_xios_field(trim(cnames(iq)),zq(:,:,iq+nmicro)/rat_mmol(iq+nmicro)) ! kg/kg -> mol/mol
+         ENDDO
+
+         ! Condensation tendencies from microphysics (mol/mol/s) :
+         DO iq = 1, size(ices_indx)
+            CALL send_xios_field('dmuficond_'//trim(nameOfTracer(gazs_indx(iq))),dmuficond(:,:,iq)/rat_mmol(gazs_indx(iq))) ! kg/kg/s -> mol/mol/s
+         ENDDO
+         
+         ! Condensation tendencies (mol/mol/s) :
+         CALL send_xios_field("dqcond_CH4",dyccond(:,:,7+nmicro))
+         CALL send_xios_field("dqcond_C2H2",dyccond(:,:,10+nmicro))
+         CALL send_xios_field("dqcond_C2H4",dyccond(:,:,12+nmicro))
+         CALL send_xios_field("dqcond_C2H6",dyccond(:,:,14+nmicro))
+         CALL send_xios_field("dqcond_C3H6",dyccond(:,:,17+nmicro))
+         CALL send_xios_field("dqcond_C4H4",dyccond(:,:,21+nmicro))
+         CALL send_xios_field("dqcond_CH3CCH",dyccond(:,:,23+nmicro))
+         CALL send_xios_field("dqcond_C3H8",dyccond(:,:,24+nmicro))
+         CALL send_xios_field("dqcond_C4H2",dyccond(:,:,25+nmicro))
+         CALL send_xios_field("dqcond_C4H6",dyccond(:,:,26+nmicro))
+         CALL send_xios_field("dqcond_C4H10",dyccond(:,:,27+nmicro))
+         CALL send_xios_field("dqcond_AC6H6",dyccond(:,:,28+nmicro))
+         CALL send_xios_field("dqcond_HCN",dyccond(:,:,35+nmicro))
+         CALL send_xios_field("dqcond_CH3CN",dyccond(:,:,39+nmicro))
+         CALL send_xios_field("dqcond_HC3N",dyccond(:,:,41+nmicro))
+         CALL send_xios_field("dqcond_NCCN",dyccond(:,:,42+nmicro))
+         CALL send_xios_field("dqcond_C4N2",dyccond(:,:,43+nmicro))
+      
+         ! Upper atmosphere chemistry variables (3D) :
+         DO iq = 1, nkim
+            CALL send_xios_field(trim(cnames(iq))//"_up",ykim_up(iq,:,:)) ! mol/mol
+         ENDDO
+         
+         ! Total atmosphere chemistry variables (3D) :
+         ! Append fields in ykim_tot for output on the total vertical grid (0->1300km)
+         DO iq = 1, nkim   
+            ! GCM levels
+            DO l = 1, nlayer
+               ykim_tot(iq,:,l) = zq(:,l,iq+nmicro)/rat_mmol(iq+nmicro)
+            ENDDO
+            ! Upper levels
+            DO l = 1, nlaykim_up
+               ykim_tot(iq,:,nlayer+l) = ykim_up(iq,:,l)
+            ENDDO
+            CALL send_xios_field(trim(cnames(iq))//"_tot",ykim_tot(iq,:,:)) ! mol/mol
+         ENDDO 
+
+         ! Surface (2D) :
+         CALL send_xios_field("evapCH4",dycevapCH4(:)) ! Pseudo-evaporation flux (mol/mol/s)
+         CALL send_xios_field("tankCH4",tankCH4(:))    ! CH4 tank at the surface (m)
+      ENDIF ! of 'if callchim'
+
 
       if (lastcall.and.is_omp_master) then
Index: trunk/LMDZ.TITAN/libf/phytitan/tpindex.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/tpindex.F	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/tpindex.F	(revision 3083)
@@ -48,4 +48,5 @@
 !     -------
 !     Adapted from the NASA Ames code by R. Wordsworth (2009)
+!     Last update : B. de Batz de Trenquelleon (2023)
 !     
 !==================================================================
@@ -55,85 +56,87 @@
       implicit none
 
-      real*8 Tref(L_NTREF)
-      real*8 pref(L_PINT)
+      ! INPUTS :
+      !=========
+      REAL,INTENT(IN) :: Tref(L_NTREF)
+      REAL,INTENT(IN) :: pref(L_PINT)
+      REAL,INTENT(IN) :: PW, TW
 
-      integer MT, MP, N, M, NP
-      real*8  PW, TW
-      real*8  PWL, LCOEF(4), T, U
+      ! OUTPUTS :
+      !==========
+      INTEGER,INTENT(OUT) :: MT, MP
+      REAL,INTENT(OUT) :: LCOEF(4)
 
-C======================================================================C
- 
-!     Get the upper and lower temperature grid indicies that bound the
-!     requested temperature. If the requested temperature is outside
-!     the T-grid, set up to extrapolate from the appropriate end.
-!     TW : temperature to be interpolated
-!     TREF : grid array
-!     MT : index of TREF for bounding new temperature
-!     U : new index (real) for temperature interpolated
+      ! LOCAL :
+      !========
+      INTEGER :: N
+      REAL :: PWL ! local value for log10(PW)
+      REAL :: TWL ! local value for TW
+      REAL :: T ! linear interpolation weight along log(pressure)
+      REAL :: U ! linear interpolation weight along temperature
 
-      IF(TW.LE.TREF(1)) THEN
+
+!     1. For the interpolation along temperature 
+!        Get the upper and lower temperature grid indicies that bound the
+!        requested temperature. If the sought temperature is below
+!        the T-grid minimum, assume that lower value. If the sought temperature
+!        is above the T-grid maximum, assume that maximum value.
+!        TW : temperature to interpolate to
+!        TREF : reference temperature array
+!        MT : index of TREF for (lower) bounding temperature
+!        U : weight for interpolation in temperature
+
+      TWL = TW
+      IF(TWL.LT.TREF(1)) THEN
+
+        ! Below lowest tabulated temperature
         MT = 1
-        IF (TW.LT.TREF(1)) THEN
-         write(*,*) 'tpindex: Caution! Temperature of upper levels lower 
-     $ than ref temperature for k-coef: k-coeff fixed for upper levels'
-         write(*,*) "         TW=",TW
-         write(*,*) "         TREF(1)=",TREF(1)
-        ENDIF
-      ELSE
+        TWL=TREF(1)*1.00
+      ELSEIF(TWL.GE.TREF(L_NTREF)) THEN
+       ! Above highest tabulated temperature
+        MT=L_NTREF-1
+        TWL = TREF(L_NTREF)*1.00
+      ELSE 
+        ! Regular case, find encompassing tabulated temperatures
         do n=1,L_NTREF-1
-          if(tw.gt.Tref(n) .and. TW.LE.TREF(N+1)) then
+          IF (TWL.GE.TREF(N) .and. TWL.LT.TREF(N+1)) THEN
             MT = n
-            goto 10
-          end if
-        end do
+            EXIT
+          END IF
+        END DO
+      
+      END IF
+!     weight for the temperature interpolation
+      U = (TWL-TREF(MT))/(TREF(MT+1)-TREF(MT))
 
-        MT = L_NTREF-1
-      
-   10   continue
-      END IF
 
-      !TB15 : case low temp : MT=1: fixed TW right above tref(1)
-      IF (MT.eq.1) THEN
-         TW=tref(1)*1.00
-!         write(*,*) 'tpindex: Caution! Temperature of upper levels lower 
-!     $than ref temperature for k-coef: k-coeff fixed for upper levels'
-!         write(*,*) "         TW=",TW
-!         write(*,*) "         TREF(1)=",TREF(1)
+!     2. For interpolation along pressure 
+!        Get the upper and lower pressure grid indicies that bound the
+!        requested pressure. If the sought pressure is below
+!        the P-grid minimum, assume that lower value. If the sought pressure
+!        is above the P-grid maximum, assume that maximum value.
+
+      PWL = log10(PW)
+      IF(PWL.LT.PREF(1)) THEN
+        ! Below lowest tabulated pressure
+        MP = 1
+        PWL=Pref(1)*1.00
+      ELSEIF(PWL.GE.PREF(L_PINT)) THEN
+        ! Above highest tabulated pressure
+        MP = L_PINT-1
+        PWL = PREF(L_PINT)*1.00
+      ELSE 
+        ! Regular case, find encompassing tabulated pressures
+        do n=1,L_PINT-1
+          IF (PWL.GE.PREF(N) .and. PWL.LT.PREF(N+1)) THEN
+            MP = n
+            EXIT
+          END IF
+        END DO
       ENDIF
 
-      U = (TW-TREF(MT))/(TREF(MT+1)-TREF(MT))
-
-!     Get the upper and lower pressure grid indicies that bound the
-!     requested pressure. If the requested pressure is outside
-!     the P-grid, set up to extrapolate from the appropriate end.
-
-      pwl = log10(pw)
-
-      do n=2,L_PINT-1
-        if(pwl.le.Pref(n)) then
-          MP = n-1
-          goto 20
-        end if
-      end do
-
-      MP = L_PINT-1
-
-   20 continue
-      
-      !TB15 : case low pressure : n=2 : fixed pwl, right above pref(1)
-      IF (MP.eq.1) THEN
-        IF (PWL.LT.PREF(1)) THEN
-         write(*,*) 'tpindex: Caution! Pressure of upper levels lower 
-     $than ref pressure for k-coef: k-coeff fixed for upper levels'
-         write(*,*) "         PWL=",PWL
-         write(*,*) "         PREF(1)=",PREF(1)
-        ENDIF
-        PWL=Pref(1)*1.00
-      ENDIF
-
-!     interpolated pressure
+!     weight for the pressure interpolation
       T = (PWL-PREF(MP))/(PREF(MP+1)-PREF(MP))
 
-!  Fill in the interpolation coefficients
+!  Build the interpolation coefficients (bilinear in temperature-log(pressure))
       LCOEF(1) = (1.0-T)*(1.0-U)
       LCOEF(2) = T*(1.0-U)
@@ -141,6 +144,3 @@
       LCOEF(4) = (1.0-T)*U
 
-   30 CONTINUE
-
-      return
-      end
+      end subroutine tpindex
Index: trunk/LMDZ.TITAN/libf/phytitan/tracer_h.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/tracer_h.F90	(revision 3082)
+++ trunk/LMDZ.TITAN/libf/phytitan/tracer_h.F90	(revision 3083)
@@ -1,3 +1,4 @@
-! WARNING (JB 27/03/2018)
+! AUTHOR : J. Burgalat (27/03/2018)
+! NOTES : Add gazs_indx by B. de Batz de Trenquelléon (31/05/2022)
 !
 ! OpenMP directives in this module are inconsistent:
@@ -38,4 +39,5 @@
   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE :: micro_indx  !! Indexes of all microphysical tracers
   INTEGER, DIMENSION(:), ALLOCATABLE, SAVE :: ices_indx   !! Indexes of all ice microphysical tracers
+  INTEGER, DIMENSION(:), ALLOCATABLE, SAVE :: gazs_indx   !! Indexes of all gazs microphysical tracers
 
   CHARACTER(len=30), DIMENSION(:), ALLOCATABLE, SAVE :: noms      !! name of the tracer
@@ -294,9 +296,12 @@
           IF (ANY(ices_indx == idx)) suffix=suffix//", ice"
         ENDIF
+        IF (ALLOCATED(gazs_indx)) THEN
+          IF (ANY(gazs_indx == idx)) suffix=suffix//", gaz"
+        ENDIF
         suffix=suffix//")"
       ELSE 
         suffix=" ()"
       ENDIF
-      WRITE(*,'(I5,(a),I6,(a))') i," -> ",idx ," : "//TRIM(noms(i))//suffix
+      WRITE(*,'(I5,(a),I6,(a))') i," -> ",idx ," : "//TRIM(noms(idx))//suffix
     ENDDO
   END SUBROUTINE dumpTracers
